package dev.shadowsoffire.apotheosis.ench.enchantments;

import net.minecraft.world.item.enchantment.DamageEnchantment;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.MobType;
import net.minecraftforge.common.ToolActions;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.entity.EquipmentSlot;
import dev.shadowsoffire.apotheosis.ench.EnchModule;
import net.minecraft.world.item.enchantment.Enchantment;

public class ShieldBashEnchant extends Enchantment
{
    public ShieldBashEnchant() {
        super(Enchantment.Rarity.RARE, EnchModule.SHIELD, new EquipmentSlot[] { EquipmentSlot.MAINHAND });
    }
    
    public int m_6183_(final int enchantmentLevel) {
        return 1 + (enchantmentLevel - 1) * 17;
    }
    
    public int m_6175_(final int enchantmentLevel) {
        return this.m_6183_(enchantmentLevel) + 40;
    }
    
    public int m_6586_() {
        return 4;
    }
    
    public boolean canApplyAtEnchantingTable(final ItemStack stack) {
        return super.canApplyAtEnchantingTable(stack) || stack.canPerformAction(ToolActions.SHIELD_BLOCK);
    }
    
    public float m_7335_(final int pLevel, final MobType pType) {
        return 3.5f * pLevel;
    }
    
    public void m_7677_(final LivingEntity user, final Entity target, final int level) {
        if (target instanceof LivingEntity) {
            final ItemStack stack = user.m_21205_();
            if (stack.getEnchantmentLevel((Enchantment)this) == level) {
                stack.m_41622_(Math.max(1, 20 - level), user, e -> e.m_21166_(EquipmentSlot.OFFHAND));
            }
        }
    }
    
    protected boolean m_5975_(final Enchantment pOther) {
        return super.m_5975_(pOther) && !(pOther instanceof DamageEnchantment);
    }
}
